package fontify;
#|########################################################################
# ftagshtml: transforms fortran and C source into HTML or PostScript or PDF.
#    Copyright (C) 2000 Olivier Cessenat.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#|########################################################################
sub F90CodeAndComments {
    if ($main::Full_Html) {
	$INIT_CODE="";
	$TERMIN_CODE="";
	$START_CODE="<FONT COLOR=$main::Couleur_Code>";
	$END_CODE="</FONT>";
	$START_COMMENT="<FONT COLOR=$main::Couleur_Comment><b>";
	$END_COMMENT="</b></FONT>";
	$ligne_ini = "</FONT></PRE><FONT COLOR=$main::Couleur_LiensIndex>\n" ;
    } else {
	$INIT_CODE="";
	$TERMIN_CODE="";
	$START_CODE="<FONT COLOR=$main::Couleur_Code>";
	$END_CODE="</FONT>";
	$START_COMMENT="<FONT COLOR=$main::Couleur_Comment><b>";
	$END_COMMENT="</b></FONT>";
	$ligne_ini = "</FONT><FONT COLOR=$main::Couleur_LiensIndex>\n" ;
    }
    $searchfc::START_CODE=$START_CODE;
    $searchfc::END_CODE=$END_CODE;
    $searchfc::START_COMMENT=$START_COMMENT;
    $searchfc::END_COMMENT=$END_COMMENT;
    $main::START_CODE=$START_CODE;
    $main::END_CODE=$END_CODE;
    $main::START_COMMENT=$START_COMMENT;
    $main::END_COMMENT=$END_COMMENT;
    $main::ligne_ini=$ligne_ini;
}
sub Fortran_Fontify {
    local($ligne)=@_;
    if ($ligne =~ /\s+(common|record|data|equivalence|implicit|parameter|pointer)\b/i) {
	$r=$1;
	$ligne =~ s/$1/<FONT COLOR=$main::Couleur_Read><u>$r<\/u><\/FONT>/;
    } elsif ($ligne =~ /\s+(character|complex|dimension|integer|logical|real)\b/i) {
	$r=$1;
	$ligne =~ s/$1/<FONT COLOR=$main::Couleur_Declare><STRONG>$r<\/STRONG><\/FONT>/;
    } elsif ($ligne =~ /\b(do|enddo|end\s+do)\b/i) {
	$r=$1;
	$ligne =~ s/$1/<FONT COLOR=$main::Couleur_Loop><I><u>$r<\/u><\/I><\/FONT>/;
    } elsif ($ligne =~ /([\d\s]+)\b(if|elseif|endif|else|end\s+if|else\s+if)\b/i) {
	$a=$1;
	$r=$2;
	$ligne =~ s/$a$r/$a<FONT COLOR=$main::Couleur_Test><I>$r<\/I><\/FONT>/;
    }
    return ($ligne);
} ;
sub F90_Fontify {
    local($ligne)=@_;
    if ($ligne =~ /\s+(common|record|data|equivalence|implicit|parameter|pointer)\b/i) {
	$r=$1;
	$ligne =~ s/$1/<FONT COLOR=$main::Couleur_Read><u>$r<\/u><\/FONT>/;
    }
    elsif ($ligne =~ /\s+(character|complex|dimension|integer|logical|real|type)\b/i) {
	$r=$1;
	$ligne =~ s/$1/<FONT COLOR=$main::Couleur_Declare><STRONG>$r<\/STRONG><\/FONT>/;
    }
    elsif ($ligne =~ /\b(do|enddo|end\s+do)\b/i) {
	$r=$1;
	$ligne =~ s/$1/<FONT COLOR=$main::Couleur_Loop><I><u>$r<\/u><\/I><\/FONT>/;
    }
    elsif ($ligne =~ /([\d\s]*)\b(if|elseif|endif|else|end\s+if|else\s+if)\b/i) {
	$a=$1;
	$r=$2;
	$ligne =~ s/$a$r/$a<FONT COLOR=$main::Couleur_Test><I>$r<\/I><\/FONT>/;
    }
    $ligne = searchfc::PRECode($ligne) ;
    return ($ligne);
} ;
1;
