package html;
#|#######################################################
#|##############################
sub bol {
    return("<ol>") ;
}
#|##############################
sub eol {
    return("</ol>") ;
}
#|##############################
sub bul {
    return("<ul>") ;
}
#|##############################
sub eul {
    return("</ul>") ;
}
#|##############################
sub br {
    return("<BR>") ;
}
#|##############################
sub chapter {
    return("<H1>$_[0]</H1>") ;
}
#|##############################
sub sepline {
    return("<!%%%%%%%%%%%%%%%%%%%%%%%%%>") ;
}
#|##############################
sub li {
    return("<li>") ;
}
#|##############################
sub liste {
# NAJ: Unused
    local($source,$index,$Routine,@numlist)=@_;
    local($localRoutine,$localFile,$localNum)=main::GetInfoRoutine($Routine) ;
    local($tag,$localtag) = ("R_$localRoutine","C_$localRoutine") ;
    if (($main::father{$Routine}) && (main::IsFatherNotTop("$main::father{$Routine}") > 0)) {
	$tag = "C_$localRoutine$localNum" ;
    }
    local($htmlligne)="";
    $numloc=1 ;
    foreach $num (@numlist) {
	if ($numloc) {
	    $numloc=0 ;
	} else {
	    $htmlligne .= " - ";
	}
	$htmlligne .= " (<A HREF=\"".CodeName($localFile,"$source").".html#$localtag$num\" ".Target("$source").index::OnClick("$localFile","$tag","$index").">$num</A>)\n";
    }
    return($htmlligne);
}
#|##############################
sub iliste {
    local($source,$index,$Routine,@numlist)=@_;
    local($localRoutine,$localFile,$localNum)=main::GetInfoRoutine($Routine) ;
    if ($localFile =~ /^\//) {
	$localFile = main::IncludeFileOfWrite($localFile) ;
    }
    if ($localNum == 0) {
	$localRoutine = $localFile ;
    }
    local($tag,$localtag) = ("R_$localRoutine","C_$localRoutine") ;
    if (($main::father{$Routine}) && (main::IsFatherNotTop("$main::father{$Routine}") > 0)) {
	$tag = "C_$localRoutine$localNum" ;
    }
    local($htmlligne)="";
    $numloc=1 ;
    foreach $num (@numlist) {
	if ($numloc) {
	    $numloc=0 ;
	} else {
	    $htmlligne .= " - ";
	}
	$htmlligne .= " (<A HREF=\"".CodeName($localFile,"$source").".html#$localtag$num\" ".Target("$source").index::OnClick("$localFile","$tag","$index").">$num</A>)\n";
    }
    return($htmlligne);
}
#|##############################
sub DeclareAnalysis {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($localRoutine,$localFile,$localNum)=main::GetInfoRoutine($Routine) ;
    local($tag) = "R_$localRoutine" ;
    if (($main::father{$Routine}) && (main::IsFatherNotTop("$main::father{$Routine}") > 0)) {
	$tag = "R_$localRoutine$localNum" ;
    }
    return($tag,$localRoutine,$localFile,$localNum) ;
}
#|##############################
sub InputAnalysis {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($localRoutine,$localFile,$localNum)=main::GetInfoRoutine($Routine) ;
    local($fic) = "$localFile";
# Attention on appelle IncludeFileOfWrite seulement sur les chemins absolus.
    if ($localFile =~ /^\//) {
	$fic = main::InputFileOfWrite($localFile) ;
    }
    &main::GetInputCibleOfWrite($localRoutine) ;
    $tag = "R_$localRoutine" ;
    if (($main::father{$Routine}) && (main::IsFatherNotTop("$main::father{$Routine}") > 0)) {
	$tag = "R_$localRoutine$localNum" ;
    }
    return($tag,$localRoutine,$fic,$localNum) ;
}
#|##############################
sub IncludeAnalysis {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($localRoutine,$localFile,$localNum)=main::GetInfoRoutineCasei($Routine) ;
    local($fic) = "$localFile";
# Attention on appelle IncludeFileOfWrite seulement sur les chemins absolus.
    if ($localFile =~ /^\//) {
	$fic = main::IncludeFileOfWrite($localFile) ;
    }
    &main::GetIncludeCibleOfWrite($localRoutine) ;
    $tag = "R_$localRoutine" ;
    if (($main::father{$Routine}) && (main::IsFatherNotTop("$main::father{$Routine}") > 0)) {
	$tag = "R_$localRoutine$localNum" ;
    }
    return($tag,$localRoutine,$fic,$localNum) ;
}
#|##############################
sub Label {
    my($lien,$htmlFile,$cref) = ("","","") ;
    $htmlFile = CodeName($localFile,"$source").".html";
    $cref = "$htmlFile#$tag";
    $lien .= "<A NAME=\"$tag\"></A>";
    if ($localFile) {
	$lien .= "<A Href=\"$cref\" ".Target("$source").index::OnClick("$localFile","$tag","$index").">$LocalName</A>";
    } else {
	$lien .= "<FONT COLOR=RED>$LocalName</FONT> is not labelled" ;
    }
    if (("$source" ne "") && ("$index" ne "")) {
	if ($localNum) {
	    $lien .= " is declared in <A Href=\"$htmlFile\" ".Target("$source").index::OnClick("$localFile","","$index").">$localFile</A> line $localNum.";
	} else {
#	    $lien .= " is labelled in <A Href=\"$htmlFile\" ".Target("$source").index::OnClick("$localFile","","$index").">$localFile</A>.";
	    if ($localFile) {
		$lien .= " is labelled in <A Href=\"$htmlFile\" ".Target("$source").index::OnClick("$localFile","","$index").">$LocalName</A>.";
	    }
	}
    }
    $ligne =~ s/$LocalName/$lien/;
    return($ligne) ;
}
#|##############################
sub Ref {
    my($lien,$htmlFile,$cref) = ("","","") ;
    if ($putFile) {
	$htmlFile = CodeName($putFile,"$source").".html";
	$cref = "$htmlFile#$tag";
	$lien = "<A Href=\"$cref\" ".Target("$source").index::OnClick("$localFile","$tag","$index").">$LocalName</A>";
    } else {
	$lien = "<Font Color=Red>$LocalName</Font>";
    }
    $ligne =~ s/$LocalName/$lien/;
#    $ligne = $lien ;
    return($ligne) ;
}
#|##############################
sub Nolabel {
    my($lien,$htmlFile,$cref) = ("","","") ;
    if ($localFile =~ /^\//) {
	$localFile = main::IncludeFileOfWrite($localFile) ;
    }
    $htmlFile = CodeName($localFile,"$source").".html";
    $cref = "$htmlFile#$tag";
    $lien = "<A Href=\"$cref\" ".Target("$source").index::OnClick("$localFile","$tag","$index").">$LocalName</A>";
    $lien = "<FONT COLOR=RED>$LocalName</FONT>" unless $localFile ;
    $ligne =~ s/$LocalName/$lien/;
    return($ligne) ;
}
#|##############################
sub DeclareLabel {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($tag,$localRoutine,$localFile,$localNum) = (DeclareAnalysis(@_)) ;
    return(&Label) ;
}
#|##############################
sub IncludeLabel {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($localRoutine,$localFile,$localNum)=main::GetInfoRoutineCasei($Routine) ;
    local($fic) = "$localFile";
# Attention on appelle IncludeFileOfWrite seulement sur les chemins absolus.
    if ($localFile =~ /^\//) {
	$fic = &main::IncludeFileOfWrite($localFile) ;
    }
    &main::GetIncludeCibleOfWrite($localRoutine) ;
    $tag = "R_$localRoutine" ;
    if (($main::father{$Routine}) && (main::IsFatherNotTop("$main::father{$Routine}") > 0)) {
	$tag = "R_$localRoutine$localNum" ;
    }
    $localFile = $fic ;
    return(&Label) ;
}
#|##############################
sub DeclareRef {
    local($source,$index,$ligne,$Routine,$LocalName,$putFile)=@_;
    local($tag,$localRoutine,$localFile,$localNum) = (DeclareAnalysis($source,$index,$ligne,$Routine,$LocalName)) ;
    if ($localFile =~ /^\//) {
	$localFile = main::IncludeFileOfWrite($localFile) ;
    }
    if ($putFile =~ /^\//) {
	$putFile = main::IncludeFileOfWrite($putFile) ;
    }
    return(&Ref) ;
}
#|##############################
sub IncludeRef {
    local($source,$index,$ligne,$Routine,$LocalName,$putFile)=@_;
    local($tag,$localRoutine,$localFile,$localNum) = (IncludeAnalysis($source,$index,$ligne,$Routine,$LocalName)) ;
    return(&Ref) ;
}
#|##############################
sub DeclareNolabel {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($tag,$localRoutine,$localFile,$localNum) = (DeclareAnalysis(@_)) ;
    return(&Nolabel) ;
}
#|##############################
sub IncludeNolabel {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($tag,$localRoutine,$localFile,$localNum) = (IncludeAnalysis(@_)) ;
    return(&Nolabel) ;
}
#|##############################
sub InputNolabel {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($tag,$localRoutine,$localFile,$localNum) = (InputAnalysis(@_)) ;
    return(&Nolabel) ;
}
#|##############################
sub Include {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($localRoutine,$localFile,$localNum)=main::GetInfoRoutine($Routine) ;
    local($tag) = "R_$localRoutine" ;
    if (($main::father{$Routine}) && (main::IsFatherNotTop("$main::father{$Routine}") > 0)) {
	$tag = "R_$localRoutine$localNum" ;
    }
    &main::GetIncludeCibleOfWrite($localFile) ;
#    print "Dealing with $localRoutine,$localFile,$localNum\n";
    local($lien,$htmlFile,$cref) = ("","","") ;
    $htmlFile = CodeName($localFile,"$source").".html";
    $cref = "$htmlFile#$tag";
    $lien = "<A Href=\"$cref\" ".Target("$source").index::OnClick("$localFile","$tag","$index").">$LocalName</A>";
    $ligne =~ s/$LocalName/$lien/;
    return($ligne) ;
}
#|##############################
sub Target {
    my($target)=@_;
    if ("$target" ne "") {
	return("TARGET=\"$target\"");
    } else {
	return("");
    }
}
#|##############################
sub CodeName {
    my($cref,$source)=@_;
    if (defined($source) && ("$source" ne "")) {
	if ($source eq "source") {
	    return("$cref".'_c');
	} elsif ($source eq "index") {
	    return("$cref".'_i');
	} else {
	    die "Unexpected source frame $source\n";
	}
    } else {
	return("$cref");
    }
}
#|##############################
sub Private_Called {
    local($htmlligne) = main::Index_Private_Called(@_) ;
    return($htmlligne);
}
#|##############################
sub Private_Defines {
    local($htmlligne) = main::Index_Private_Defines(@_) ;
    return($htmlligne);
}
#|##############################
sub Private_Calls {
    local($htmlligne) = main::Index_Private_Calls(@_) ;
    return($htmlligne);
}
#|##############################
sub Private_Uses {
    local($latexligne) = main::Index_Private_Uses(@_) ;
    return($latexligne);
}
#|##############################
sub Private_Used {
    local($htmlligne) = main::Index_Private_Used(@_) ;
    return($htmlligne);
}
#|##############################
sub Private_Includes {
    local($htmlligne) = main::Index_Private_Includes(@_) ;
    return($htmlligne);
}
#|##############################
sub Private_Included {
    local($htmlligne) = main::Index_Private_Included(@_) ;
    return($htmlligne);
}
#|##############################
sub Private_Inputs {
    local($htmlligne) = main::Index_Private_Inputs(@_) ;
    return($htmlligne);
}
#|##############################
sub Private_Inputed {
    local($htmlligne) = main::Index_Private_Inputed(@_) ;
    return($htmlligne);
}
#|#######################################################
1;
