package index;
#|########################################################################
# ftagshtml: transforms fortran and C source into HTML or PostScript or PDF.
#    Copyright (C) 2000 Olivier Cessenat.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#|########################################################################
sub FileName {
    local($nom)=@_;
    if ($nom =~ /([\w+_\.]+)$/) { $nom=$1; }
    return($nom);
}
#|#######################################################
sub GetIncludeCibleOfWrite { # donne le nom cible du fichier include
   if ( $_[0] =~ /^\.\.\/(.*)/ ) {
      $_[0] = $1 ;
   }
   if ( $_[0] =~ /^\.\/(.*)/ ) {
      $_[0] = $1 ;
   }
   $_[0] =~ s/\//_/g;
}
#|#######################################################
sub En_Tete_Input {
    local($file,$fic,$source)=@_;
    local($ligne)="";
    $file_bis = $fic ;
    $main::Verbatim_Style = 0;
    $enteteloc=main::En_Tete_All($file_bis,"input",$source);
# en-tete du fichier
#-------------------
    $ligne="<HTML><HEAD>
<TITLE>$fic $main::RepCodeSource</TITLE></HEAD>
<BODY BGCOLOR=WHITE LINK=BLUE ALINK=GREEN VLINK=#9910DD>
<H3 align=center>$fic</H3>
$enteteloc
";
    if (($source) && ("$source" eq "source")) {
	$ligne .= "<P> Liste des fichiers utilisant <A HREF=\"${fic}_i.html\" TARGET=\"index\">$file</A>.";
    } else {
	$ligne .= "<P> Liste des fichiers utilisant <A HREF=\"inpuindex_c.html#R_$fic\" TARGET=\"source\">$fic</A>.";
    }
    $ligne .= "<HR>\n";
    return($ligne);
} ;
#|#######################################################
sub Fortran_Input_Construct {
    local($file,$cible)=@_;
    local($ligne)="";
    if (open (INPUT, $file)){
	open (TARGET, ">$main::DIRE/${cible}_c.html") or die "Probleme 0" ;
	open (LEFTINDEX, ">$main::DIRE/${cible}_i.html") or die "Probleme 0" ;
	open (MAINFRAME, ">$main::DIRE/${cible}.html") or die "Probleme 0" ;
	print MAINFRAME '<html>
<head>
   <title>'.$cible.'</title>
</head>
<frameset COLS="25%,*" BORDER="1" MARGINHEIGHT="0" MARGINWIDTH="0">
  <frame SRC="'.${cible}.'_i.html" NAME="index">
  <frame SRC="'.${cible}.'_c.html" NAME="source">
</frameset>
</html>' ;
        close (MAINFRAME) ;
        local($header)="";
        $header = &En_Tete_Input($file,$cible,"source");
	print TARGET $header ;
	print TARGET "<A Name=R_$file></A>" ;
#        $header = &En_Tete_Input($file,$cible,"index");
#	    $header .= &Manage_Index_Input($file,$cible,"source");
	print LEFTINDEX $header ;
        $ligne = &{$main::affiche{"Private_Inputs"}}($totalRoutine,"source") ;
        $ligne .= &{$main::affiche{"Private_Inputed"}}($totalRoutine,"source") ;
        print LEFTINDEX "$ligne" ;
        close (LEFTINDEX) ;
        $ligne = "";
	local($normalligne)="";
	if ($main::opt_hevea) {
	    while (defined($LIGNEINP=<INPUT>)) {
		$ligne .= $LIGNEINP ;
		if ($LIGNEINP =~ /[<>]/) {
		    $LIGNEINP =~ s/</&lt;/g ;
		    $LIGNEINP =~ s/>/&gt;/g ;
		}
		$normalligne .= &main::LatexBuiltinProcess($LIGNEINP);
	    }
	    $hevea="$main::DIRE/hevea_$cible";
	    $hevea =~ s/\.\w+$//;
	    local($hevealigne) = &main::LatexHeveaProcess($ligne);
	    &main::HeveaConstructFile($hevea,$hevealigne);
	    local($target)="hevea_$cible";
	    $target =~ s/\.\w+$//;
	    if ($target =~ /.*\/([\w\._]+)/) {
		local($target)=$1 ;
	    }
	    print TARGET "<BR><A Href=$target.html>Hevea Translation</A>\n";
	    print TARGET "<BR><A Href=$ftagshtmldoc/browser.html>Correctly Configure Netscape.</A>\n<BR>";
	    print TARGET "$normalligne\n";
	} else {
	    while (defined($LIGNEINP=<INPUT>)) {
		chop($LIGNEINP);
		$ligne .= &main::LatexBuiltinProcess($LIGNEINP);
	    }
	    print TARGET "$ligne\n";
	}
        print TARGET "<HR>\n";
        print TARGET "</BODY></HTML>\n";
        close(TARGET);
        close(INPUT);
    } else {
        print "Le fichier input $file n'existe pas.\n";
    }
}
#|#######################################################
sub OpenIndex {
# Dfinit un titre de code d'index.
    local($titre)=@_;
    local($ligne)="";
    $ligne="<HTML>
<HEAD>
<TITLE>$titre</TITLE>
</HEAD>
<SCRIPT LANGUAGE=JAVASCRIPT>
function LienDynamique(document2){
   top.index.location=document2 ;
}
</SCRIPT>
<BODY BGCOLOR=WHITE LINK=BLUE ALINK=GREEN VLINK=#9910DD>
<H1 align=center>$titre</H1>
";
    return($ligne);
}
#|#######################################################
sub OpenMainFrame {
# Dfinit les frames de base
    local($index,$source,$titre)=@_;
    local($ligne)='<html>
<head>
   <title>'.$titre.'</title>
</head>
<frameset COLS="25%,*" BORDER="1" MARGINHEIGHT="0" MARGINWIDTH="0">
  <frame SRC="'.$index.'.html" NAME="index">
  <frame SRC="'.$source.'.html" NAME="source">
</frameset>
</html>' ;
    return($ligne);
}
#|#######################################################
sub Index_Input {
# index des inputs
    if ($ENV{FTAGSHTML_DOC}) {
	$ftagshtmldoc="$ENV{FTAGSHTML_DOC}" ;
    } else {
	$ftagshtmldoc="$ENV{FTAGSHTML_DIR}/doc" ;
    }
    open(MAINFRAME,">$main::DIRE/inpuindex.html");
    print MAINFRAME OpenMainFrame("index","inpuindex_c","Index des inputs de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/inpuindex_c.html");
    print INDEX OpenIndex("Index des inputs de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    @liste=sort keys %{main::latexinputed} ;
    print INDEX main::Build_Index_Chapter("source","index","Inputs","html",@liste);
    print INDEX "</BODY></HTML>\n";
    foreach $file (@liste) {
	($localFile,$a,$b)=&main::GetInfoRoutine($file) ;
	$cible = $localFile ;
	&main::GetInputCibleOfWrite($cible) ;
	$totalRoutine = $file ;
	&Fortran_Input_Construct($localFile,$cible);
    }
    close(INDEX);
#    print STDOUT &main::save_hash_in_file ("label", %main::label);
} ;
#|#######################################################
sub Old_Index_Input {
# index des input
    open(MAINFRAME,">$main::DIRE/inpuindex.html");
    print MAINFRAME OpenMainFrame("index","inpuindex_c","Index des commentaires de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/inpuindex_c.html");
    print INDEX OpenIndex("Index des commentaires de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    @liste=sort @main::listetex ;
    if ($ENV{FTAGSHTML_DOC}) {
	$ftagshtmldoc="$ENV{FTAGSHTML_DOC}" ;
    } else {
	$ftagshtmldoc="$ENV{FTAGSHTML_DIR}/doc" ;
    }
    if (@liste) {
	print INDEX "<H3>Liste alphabtique des variables (numro de ligne) :</H3><OL>\n";
	while (@liste) {
	    $nom=shift @liste;
	    $cible = $nom ;
	    &GetIncludeCibleOfWrite($cible) ;
	    &Fortran_Input_Construct($nom,$cible);
	    $ligne=&Manage_Index_Input($nom,$cible,"source","index");
	    print INDEX "<LI>$ligne\n";
	}
    } else {
	print INDEX "<H3>Pas de variable dfinie dans un fichier spar.</H3>\n";
	print INDEX "<H3>C'est dommage, vous risquez de construire des commentaires";
	print INDEX " contradictoires sur des variables communes  plusieurs";
	print INDEX " sous-programmes.</H3>\n";
	print INDEX "<H3>De plus, cette technique permet de constituer deux";
	print INDEX " types de source: l'un comment, l'autre non.</H3><OL>\n";
    }
    &Index_Ferme;
} ;
#|#######################################################
sub OnClick {
    local($cref,$tag,$index)=@_;
    if (($index) && ("$index" ne "")) {
	if (($tag) && ("$tag" ne "")) {
	    return(" onClick=LienDynamique(\"${cref}_i.html#$tag\")");
        } else {
	    return(" onClick=LienDynamique(\"${cref}_i.html\")");
	}
    } else {
	return("");
    }
}
#|#######################################################
sub Index_Fichiers {
    local(@liste)=(sort @_) ;
    local(@listebis)=() ;
    foreach $file (@liste) {
	if ($file =~ /\.(h|fh|fc)$/i) {
	    push(@listebis,"$main::Include_Unique{$file}:$file:0");
	} else {
	    push(@listebis,"$file:$file:0");
	}
    }
# index des fichiers
    open(MAINFRAME,">$main::DIRE/fileindex.html");
    print MAINFRAME OpenMainFrame("index","fileindex_c","Index des fichiers de $main::RepCodeSource");
    close(MAINFRAME);
    open(INDEX,">$main::DIRE/fileindex_c.html");
    print INDEX OpenIndex("Index des fichiers de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    local($source,$index)=("source","index");
    print INDEX main::Build_Index_Chapter("source","index","Fichiers","html",@listebis);
    print INDEX "</BODY></HTML>\n";
    close(INDEX);
}
#|#######################################################
sub Index_Include {
# index des includes
    open(MAINFRAME,">$main::DIRE/inclindex.html");
    print MAINFRAME OpenMainFrame("index","inclindex_c","Index des includes de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/inclindex_c.html");
    print INDEX OpenIndex("Index des includes de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    @liste=sort keys %{main::f90included} ;
    print INDEX main::Build_Index_Chapter("source","index","Includes","html",@liste);
    print INDEX '<IMG SRC="cooldog.gif" WIDTH=100%>'."\n";
    print INDEX "</BODY></HTML>\n";
    close(INDEX);
} ;
#|#######################################################
sub Manage_Index_Include {
    die ;
}
#|#######################################################
# Stolen from latex2html
sub get_date {
    local($format,$order) = @_;
    local(@lt) = localtime;
    local($d,$m,$y) = @lt[3,4,5];
    if ($format =~ /ISO/) {
	sprintf("%4d-%02d-%02d", 1900+$y, $m+1, $d);
    } elsif ($format) {
	if ($order) { eval "sprintf(".$format.",".$order.")"; }
	else { sprintf($format, $d, $m+1, 1900+$y); }
    } else { sprintf("%d/%d/%d", $m+1, $d, 1900+$y); }
}

sub address_data {
    local($user, $date, $_);
    local($format,$order) = @_;
    # Get author email address and current date.
    ($user = (getpwuid ($<))[6]) =~ s/,.*//;
    ($user, &get_date($format,$order));
}
#|#######################################################
sub Index_Index {
    local(@lt) = localtime;
    local($d,$m,$y) = @lt[3,4,5];
    @address_data = address_data('ISO');
    open(MAINFRAME,">$main::DIRE/index.html");
    print MAINFRAME '<HTML>
<HEAD>
<TITLE>Code '.$main::RepCodeSource.' de '.$main::USER.'.</TITLE>
</HEAD>
<BODY BGCOLOR=YELLOW LINK=BLUE ALINK=GREEN VLINK=#9910DD>
<H1>Code '.$main::RepCodeSource.' de '.$main::USER.'.</H1>
Traduction du code '.$main::RepCodeSource.' en HTML par
<A Href="http://cessenat.free.fr/pub/ftagshtml.html">ftagshtml</A>
le '. scalar localtime() .'.
<IMG SRC="cooldog.gif" WIDTH=100%><BR>
</BODY></HTML>';
#le '. $address_data[1].'.
#pour '. $address_data[0].'
#    foreach $t (getpwuid ($<)) { print "t=$t\n"; } ;
    close(MAINFRAME);
}

#|#######################################################
sub Index_Routines {
    open(MAINFRAME,">$main::DIRE/routindex.html");
    print MAINFRAME OpenMainFrame("index","routindex_c","Index des subroutines de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/routindex_c.html");
    print INDEX OpenIndex("Index des subroutines de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    (@liste)=(sort keys %main::routines) ;
    if (@liste) {
	$lang = "html" ;
	print INDEX main::Build_Index_Chapter("source","index","Routines",$lang,@liste);
    } else {
	print INDEX "<H1>No subroutine in $main::RepCodeSource.</H1>\n";
    }
    print INDEX '<IMG SRC="cooldog.gif" WIDTH=100%>'."\n";
    print INDEX "</BODY></HTML>\n";
    close(INDEX);
} ;
#|#######################################################
sub Index_Principal {
    $lang = "html";
    (%affiche)=(main::TalkInLaTeXOrHtml($lang,%main::delegue));
    &Index_Index;
    open(MAINFRAME,">$main::DIRE/progindex.html");
    print MAINFRAME OpenMainFrame("index","progindex_c","Index des programmes de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/progindex_c.html");
    print INDEX OpenIndex("Index des programmes de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    (@liste)=(sort keys %main::programmes);
    if (@liste) {
	$lang = "html" ;
	print INDEX main::Build_Index_Chapter("source","index","Programmes",$lang,@liste);
    } else {
	print INDEX "<H1>No main entry point in $main::RepCodeSource.</H1>\n";
    }
    print INDEX '<IMG SRC="cooldog.gif" WIDTH=100%>'."\n";
    print INDEX "</BODY></HTML>\n";
    close(INDEX);
}
#|#######################################################
sub Index_Modules {
# index des modules
    open(MAINFRAME,">$main::DIRE/moduleindex.html");
    print MAINFRAME OpenMainFrame("index","moduleindex_c","Index des modules de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/moduleindex_c.html");
    print INDEX OpenIndex("Index des modules de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    (@liste)=(sort keys %main::module) ;
    if (@liste) {
	$lang = "html" ;
	print INDEX main::Build_Index_Chapter("source","index","Modules",$lang,@liste);
    } else {
	print INDEX "<H1>No fortran module in $main::RepCodeSource.</H1>\n";
    }
    print INDEX '<IMG SRC="cooldog.gif" WIDTH=100%>'."\n";
    print INDEX "</BODY></HTML>\n";
    close(INDEX);
} ;

#|#######################################################
sub Index_Fonctions {
# index des fonctions
    open(MAINFRAME,">$main::DIRE/foncindex.html");
    print MAINFRAME OpenMainFrame("index","foncindex_c","Index des fonctions de $main::RepCodeSource");
    close(MAINFRAME);
    open(INDEX,">$main::DIRE/foncindex_c.html");
    print INDEX OpenIndex("Index des fonctions de $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    (@liste)=(sort keys %main::functions) ;
    if (@liste) {
	$lang = "html" ;
	print INDEX main::Build_Index_Chapter("source","index","Functions",$lang,@liste);
    } else {
	print INDEX "<H1>No function in $main::RepCodeSource.</H1>\n";
    }
    print INDEX '<IMG SRC="cooldog.gif" WIDTH=100%>'."\n";
    print INDEX "</BODY></HTML>\n";
    close(INDEX);
} ;
#|#######################################################
sub Gere_Index {
    local($totalRoutine)=main::GetTotalRoutine($nom) ;
    $ligne  = &{$affiche{"Private_Called"}}($totalRoutine,"source","index") ;
    $ligne .= &{$affiche{"Private_Calls"}}($totalRoutine,"source","index") ;
#    $ligne=(main::Gere_Index_Appelants($nom,"source","index")) ;
#    $ligne.=(main::Gere_Index_Appellees($nom,"source","index")) ;
    print INDEX "$ligne";
} ;
#|#######################################################
sub Index_Ferme {
# fermeture des fichiers HTML
print INDEX "</OL>\n";
print INDEX '<IMG SRC="cooldog.gif" WIDTH=100%>'."\n";
print INDEX "</BODY></HTML>\n";
close(INDEX);
} ;
1;
